//*************************************************************
//**  MP3 (MPEG) Information Copyright (c) 06.2000 by ToMaS  **
//**       ToMaS - tzveglic@hotmail.com                      **
//**       URL: www.gepardstudio.f2s.com                     **
//*************************************************************
unit ID3_tag;

interface
Type TID3Tag = Record
                 Title  :String[31];
                 Artist :String[31];
                 Album  :String[31];
                 Year   :String[5];
                 Genre  :Byte;
                 Comment:String[31];
                 Found  :Boolean;
                 Name   :String;
                 Size   :LongInt;
               End;

Procedure LoadID3(name:String);
Function  SaveID3(name:String):Boolean;  //returns true if save succed

Var ID3Tag:TID3Tag;
    Genre:Array[0..$93]Of String[20]=('Blues','Classic Rock','Country','Dance','Disco',
    'Funk','Grunge','Hip-Hop','Jazz','Metal','New Age','Oldies','Other','Pop','R&B','Rap',
    'Reggae','Rock','Techno','Industrial','Alternative','Ska','Death Metal','Pranks',
    'Soundtrack','Euro-Techno','Ambient','Trip-Hop','Vocal','Jazz+Funk','Fusion','Trance',
    'Classical','Instrumental','Acid','House','Game','Sound Clip','Gospel','Noise',
    'Alt. Rock','Bass','Soul','Punk','Space','Meditative','Instrumental Pop','Instrumental Rock',
    'Ethnic','Gothic','Darkwave','Techno-Industrial','Electronic','Pop-Folk','Eurodance',
    'Dream','Southern Rock','Comedy','Cult','Gangsta Rap','Top 40','Christian Rap',
    'Pop/Funk','Jungle','Native American','Cabaret','New Wave','Psychedelic','Rave',
    'Showtunes','Trailer','Lo-Fi','Tribal','Acid Punk','Acid Jazz','Polka','Retro',
    'Musical','Rock & Roll','Hard Rock','Folk','Folk/Rock','National Folk','Swing',
    'Fast-Fusion','Bebob','Latin','Revival','Celtic','Bluegrass','Avantgarde',
    'Gothic Rock','Progressive Rock','Psychedelic Rock','Symphonic Rock','Slow Rock',
    'Big Band','Chorus','Easy Listening','Acoustic','Humour','Speech',
    'Chanson','Opera','Chamber Music','Sonata','Symphony','Booty Bass','Primus','Porn Groove',
    'Satire','Slow Jam','Club','Tango','Samba','Folklore','Ballad','Power Ballad',
    'Rhytmic Soul','Freestyle','Duet','Punk Rock','Drum Solo','A Cappella','Euro-House',
    'Dance Hall','Goa','Drum & Bass','Club-House','Hardcore','Terror','Indie','BritPop',
    'Negerpunk','Polsk Punk','Beat','Christian Gangsta','Heavy Metal','Black Metal',
    'Crossover','Contemporary Ch','Christian Rock','Merengue','Salsa','Trash Metal',
    'Anime','JPop','Synthpop');
implementation
Uses SysUtils;
Function Find_File(s:String):Integer;//returns 1 if found file
Var attr:integer;SearchRec:TSearchRec;Found:Integer;
Begin
  Attr:=faAnyFile;
  Found:=FindFirst(s,Attr,SearchRec);
  FindClose(SearchRec);
  If Found=0 Then Find_File:=1 Else Find_File:=0;
End;
Function Find_File2(s:String):Integer;//returns atributes of file
Var attr:integer;SearchRec:TSearchRec;Found:Integer;
Begin
  Attr:=faAnyFile;
  Found:=FindFirst(s,Attr,SearchRec);
  If Found=0 Then Find_File2:=SearchRec.Attr Else Find_File2:=0;
  FindClose(SearchRec);
End;
Procedure DelSpace(Var s:String);//delete spaces from string end
Var l,a:Integer;
Begin
  l:=Length(s)+1;a:=l;
  Repeat
    dec(l);
  Until s[l]<>Chr($20);
  Delete(s,l+1,a-l+1);
End;

Procedure LoadID3(name:String);
Var f:File;ch:Char;s:string;
    i:Integer;Attrib:Integer;
Begin
  ID3Tag.Title:='';ID3Tag.Artist:='';ID3Tag.Album:='';
  ID3Tag.Year:='';ID3Tag.Comment:='';
  s:='';
  ID3Tag.Found:=False;
  If (Find_File(name)=1)Then
  Begin
    AssignFile(f,name);
    FileMode:=0;
    Reset(f,1);
    ID3Tag.Name:=name;
    ID3Tag.Size:=FileSize(f);
    Seek(f,Filesize(f)-128);//id3tag is at the end of mp3 file-128
    BlockRead(f,ch,1);s:=s+Upcase(ch);
    BlockRead(f,ch,1);s:=s+Upcase(ch);
    BlockRead(f,ch,1);s:=s+Upcase(ch);
    If s='TAG' Then
    Begin
      ID3Tag.Found:=True;
      s:='';
      For i:=1 To 30 Do
        Begin BlockRead(f,ch,1);s:=s+ch;End;DelSpace(s);ID3Tag.Title:=s;s:='';
      For i:=1 To 30 Do
        Begin BlockRead(f,ch,1);s:=s+ch;End;DelSpace(s);ID3Tag.Artist:=s;s:='';
      For i:=1 To 30 Do
        Begin BlockRead(f,ch,1);s:=s+ch;End;DelSpace(s);ID3Tag.Album:=s;s:='';
      For i:=1 To 4 Do
        Begin BlockRead(f,ch,1);s:=s+ch;End;ID3Tag.Year:=s;s:='';
      For i:=1 To 30 Do
        Begin BlockRead(f,ch,1);s:=s+ch;End;DelSpace(s);ID3Tag.Comment:=s;s:='';
      BlockRead(f,ch,1);ID3Tag.Genre:=Ord(ch);
    End;
    CloseFile(f);
  End;
End;

Function SaveID3(name:String):Boolean;
Var f:File;ch:Char;s:string;t:Array[1..30]Of char;
    i:Integer;Attrib:Integer;sek:LongInt;
Begin
  SaveID3:=False;
  s:='';
  If (Find_File(name)=1)Then
  Begin
    Attrib:=Find_File2(name);
    If (Attrib And faReadOnly)=0 Then//if file is readonly
    Begin
      AssignFile(f,name);
      FileMode:=0;
      Reset(f,1);
      ID3Tag.Name:=name;
      ID3Tag.Size:=FileSize(f);
      Seek(f,Filesize(f)-128);//id3tag is at the end of mp3 file-128
      BlockRead(f,ch,1);s:=s+Upcase(ch);
      BlockRead(f,ch,1);s:=s+Upcase(ch);
      BlockRead(f,ch,1);s:=s+Upcase(ch);
      If s='TAG' Then Sek:=FileSize(f)-128 Else Sek:=FileSize(f);
      CloseFile(f);

      AssignFile(f,name);
      FileMode:=1;
      Reset(f,1);
        Seek(f,sek);
        BlockWrite(f,'TAG',3);
        For i:=1 to 30 do t[i]:=Chr($20);
        For i:=1 To Length(ID3Tag.Title) Do t[i]:=ID3Tag.Title[i];
        For i:=1 To 30 Do BlockWrite(f,t[i],1);

        For i:=1 to 30 do t[i]:=Chr($20);
        For i:=1 To Length(ID3Tag.Artist) Do t[i]:=ID3Tag.Artist[i];
        For i:=1 To 30 Do BlockWrite(f,t[i],1);

        For i:=1 to 30 do t[i]:=Chr($20);
        For i:=1 To Length(ID3Tag.Album) Do t[i]:=ID3Tag.Album[i];
        For i:=1 To 30 Do BlockWrite(f,t[i],1);

        For i:=1 to 4 do t[i]:=Chr($20);
        For i:=1 To Length(ID3Tag.Year) Do t[i]:=ID3Tag.Year[i];
        For i:=1 To 4 Do BlockWrite(f,t[i],1);

        For i:=1 to 30 do t[i]:=Chr($20);
        For i:=1 To Length(ID3Tag.Comment) Do t[i]:=ID3Tag.Comment[i];
        For i:=1 To 30 Do BlockWrite(f,t[i],1);

        ch:=Chr(ID3Tag.Genre);BlockWrite(f,ch,1);

      CloseFile(f);
      SaveID3:=True;
    End;
  End;
End;

end.
